class Pettanr.FoldersController extends Pettanr.AppController
  
  index: () ->
    @trigger('title', @params)
    @filer_list()
    @trigger('done', @params)
  
  root: () ->
    @set_model()
    Pettanr.Folder.Root.retrieve(null, this, {
      success: (@item) => 
        @children_html()
      fail: (response, opt) => 
        @trigger('fail', response, opt)
      force: true
    })
  
  show_html_format: (format) -> 
  
  show: () ->
    @set_model()
    folder = new Pettanr.FolderWatch({id: @params['id']})
    folder.retrieve(this, {
      success: (@item) => 
        @render_show()
      fail: (response, opt) => 
        @trigger('fail', response, opt)
      force: true
    })
  
  
  render_show: () -> 
    switch @params['format']
      when 'prof'
        @show_prof()
      when 'html'
        @show_html()
  
  show_html: () -> 
    if @item.is_remote()
      @trigger('other', @item.remote_url())
    else
      @children_html()
  
  children_html: () -> 
    @trigger('title', @params, @item.get('name'))
    collection = new Pettanr.Folder.Children({id: @item.get('id')})
    collection.fetch({
      success: (models, response, opt) =>
        filer = new Locmare.Filer({
          item_name: 'folder', 
          items: collection.models, 
          pager: null, 
        })
        filer.render()
        @trigger('ready', filer)
        @trigger('done', @params)
      error: (item, response, opt) =>
        @trigger('fail', response, opt)
    })
  
  count: () ->
  
  new: () ->
    @trigger('title', @params)
    @form_new()
    @trigger('done', @params)
  
  edit: () ->
    @trigger('title', @params)
    @form_edit()
    @trigger('done', @params)
  
  # for remote folder
  refresh: (view) ->
    @trigger('ready', view)
  
  title: (params, str) ->
    @trigger('title', params, str)
  
  done: (params) ->
    @trigger('done', params)
  
  deny: (params, form, safe_url) ->
    @trigger('deny', params, form, safe_url)
  
  @is_deny_action_on_picker: (params) ->
    switch params['action']
      when 'new'
        true
      when 'edit'
        true
      else
        false
  
