class Locmare.FormModule.FieldModule.HelperModule.TailAngle extends Locmare.FormModule.FieldModule.HelperModule.Base
  className: 'r-wrap'
  
  # wrapper
  initialize: (options) ->
    super(options)
    @down = new Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Down({field: @field, helper: this})
    @up = new Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Up({field: @field, helper: this})
    @reset = new Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Reset({field: @field, helper: this})
    @listenTo(this, 'down', @down_click)
    @listenTo(this, 'up', @up_click)
    @listenTo(this, 'reset', @reset_click)
  
  render: () ->
    @attr = {
      #style: 'display: block' # row break?
    }
    this.$el.attr(@attr)
    this.$el.html('')
    this.$el.append(@down.render().el)
    this.$el.append(@up.render().el)
    this.$el.append(@reset.render().el)
    this
  
  refresh: () -> 
  
  r_step: () ->
    @field.item().r_step()
  
  # balloon r helper
  
  set_r: (r) ->
    @field.tag.$el.val(r)
    @field.change()
  
  r: () ->
    parseInt(@field.val())
  
  down_click: () ->
    @set_r(Math.floor(@r() - @r_step()))
  
  up_click: () ->
    @set_r(Math.floor(@r() + @r_step()))
  
  reset_click: () ->
    @set_r(0)
  
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Down extends Pettanr.View
  tagName: 'button'
  className: 'r-down'
  events: {
    'click': 'click'
  }
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
  
  render: () ->
    this.$el.html('<')
    this
  
  click: () -> 
    @helper.trigger('down')
    false
    
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Up extends Pettanr.View
  tagName: 'button'
  className: 'r-up'
  events: {
    'click': 'click'
  }
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
  
  render: () ->
    this.$el.html('>')
    this
  
  click: () -> 
    @helper.trigger('up')
    false
  
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Reset extends Pettanr.View
  tagName: 'button'
  className: 'r-reset'
  events: {
    'click': 'click'
  }
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
  
  render: () ->
    this.$el.html('reset')
    this
  
  click: () -> 
    @field.tag.$el.val(0)
    @helper.trigger('reset')
    false
  
