$ ->
  _.templateSettings = {
    interpolate: /\<\&\=(.+?)\&\>/g,
    evaluate: /\<\&(.+?)\&\>/g
  }
  locale = $("html").attr('lang')
  env = $("html").attr('env')
  I18n.defaultLocale = locale
  I18n.locale = locale
  I18n.fallbacks = true
  jQuery.timeago.settings.lang = locale
  Backbone.fetchCache.localStorage = false
  loaded_manifest = null
  loaded_local_manifest = null
  $.ajaxSetup({async: false})
  $.getJSON('/manifest.json', null, (data) =>
    loaded_manifest = new Manifest(data) )
  $.getJSON('/local_manifest.json', null, (data) =>
    loaded_local_manifest = new LocalManifest(data)
  )
  $.ajaxSetup({async: true})
  
  Manifest.set_manifest(loaded_manifest)
  LocalManifest.set_manifest(loaded_local_manifest)
  loaded_manifest.init()
  loaded_local_manifest.init()
  
  if env == 'development'
    window.onbeforeunload = (e)->
      return('leave?')
  Backbone.history.start({silent: true, pushState: true, root: '/'})
  
  Pettanr.cache = new Pettanr.Cache({operators: new Pettanr.Operator({})})
  layout = if Pettanr.is_sns()
    new Pettanr.View.Layout.Sns()
  else
    new Pettanr.View.Layout.Blog()
  $('#pettanr').html(layout.render().el)
  layout.start()
  
