class Peta.ElementNestableContent extends Peta.Content
  element_items: (element_model) ->
    n = @my_class().my_manifest().associations.child_element_name(element_model)
    @get(n)
  
  elements_items: () ->
    r = _.map @my_class().child_models(), (element_model) =>
      @element_items(element_model)
    _.compact(_.flatten(r))
  
  boosts: (level) ->
    super(level)
    _.each @elements_items(), (item) =>
      item.boosts(level) if item
  
  dig_elements: () ->
    items = []
    @_dig_elements(items, @attributes)
    items
  
  _dig_elements: (items, attributes) ->
    _.each attributes, (attribute, name) =>
      a = @my_class().my_manifest().associations
      if a.has_many[name]
        _.each attribute, (attr) =>
          items.push(attr)
          Array.prototype.push.apply(items, attr.dig_elements())
      if a.has_one[name]
        items.push(attribute)
        Array.prototype.push.apply(items, attribute.dig_elements())
  
  load_elements: (options) ->
    @_load_elements(@dig_elements(), options)
  
  _load_elements: (items, options) ->
    if _.isEmpty(items)
      options.success.call(options.context, this)
      return
    item = items.shift()
    item.fetch({
      success: (model, response, opt) => 
        @_load_elements(items, options)
      error: (item, response, opt) =>
        options.fail.call(options.context, response, opt)
    })
  
  decoded_attributes: () ->
    attributes = {}
    _.each @attributes, (attribute, name) =>
      a = @my_class().my_manifest().associations
      decoded = if a.has_many[name]
        # has many association
        model = a.has_many[name].model()
        _.map attribute, (attr) =>
          child = @cache_child(model, attr)
          child.attributes = child.decoded_attributes()
          child
      else if a.has_one[name]
        # has one association
        model = a.has_one[name].model()
        child = @cache_child(model, attribute)
        child.attributes = child.decoded_attributes()
        child
      else
        attribute
      attributes[name] = decoded
    attributes
  
  replaced_attributes: (options = {}) ->
    attributes = {}
    _.each @attributes, (attribute, name) =>
      console.log name
      console.log attribute
      a = @my_class().my_manifest().associations
      replaced = if a.has_many[name]
        # has many association
        _.map attribute, (decoded) =>
          child = if options.hold
            @replace_and_hold_element(decoded)
          else
            @replace_element(decoded)
          console.log child
          child.attributes = child.replaced_attributes(options)
          child
      else if a.has_one[name]
        # has one association
        child = if options.hold
          @replace_and_hold_element(attribute)
        else
          @replace_element(attribute)
        child.attributes = child.replaced_attributes(options)
        child
      else
        attribute
      console.log replaced
      attributes[name] = replaced
    attributes
  
  replace_element: (decoded_child) ->
    cached_child = Pettanr.cache.restore(decoded_child)
    item = if cached_child
      cached_child
    else
      model = decoded_child.my_class()
      caching_item = new model()
      Pettanr.cache.store(caching_item)
    item
  
  cache_child: (model, attr) ->
    attr_without_element = {}
    _.each attr, (a, n) ->
      if !_.isObject(a) and !_.isArray(a)
        attr_without_element[n] = a
    decoded_child = new model(attr_without_element)
    cached_child = Pettanr.cache.restore(decoded_child)
    holden_item = if cached_child
      cached_child.hold()
    else
      Pettanr.cache.store(decoded_child).hold()
    holden_item.attributes = attr
    holden_item
  
  hold: () ->
    super()
  
  fix: () ->
    super()
    @fix_elements()
  
  release: () ->
    super()
    @release_elements()
  
  release_elements: () ->
    _.each @attributes, (elements, name) =>
      a = @my_class().my_manifest().associations
      if a.has_many[name]
        # has many association
        _.each elements, (element) =>
          element.release()
      else if a.has_one[name]
        # has one association
        elements.release()
  
  fix_elements: () ->
    return 
    _.each @attributes, (elements, name) =>
      a = @my_class().my_manifest().associations
      if a.has_many[name]
        # has many association
        _.each elements, (element) =>
          if @has('_destroy')
            element.release()  # destroy element by editor
          else
            element.fix()
      else if a.has_one[name]
        # has one association
        if @has('_destroy')
          element.release()
        else
          element.fix()
  
